import { IInstallOpts } from '../service/builder/webpack';
import { IMaterialItem, IWeAppData, IPlugin } from '../../weapps-core';
import { BuildType, GenerateMpType, WebpackBuildCallBack, WebpackModeType } from '../types/common';
import { DEPLOY_MODE, RUNTIME } from '../../types';
export declare type BuildAppProps = {
    dependencies: IMaterialItem[];
    mainAppSerializeData?: IWeAppData;
    subAppSerializeDataList?: IWeAppData[];
    appKey: string;
    nodeModulesPath: string;
    publicPath?: string;
    buildTypeList: BuildType[];
    mode?: WebpackModeType;
    watch?: boolean;
    generateMpType: GenerateMpType;
    generateMpPath?: string;
    isCleanDistDir?: boolean;
    plugins?: IPlugin[];
    extraData?: {
        isComposite: boolean;
        compProps: any;
    };
    domain: string;
};
export declare function buildWebApp({ mainAppSerializeData, subAppSerializeDataList, dependencies, appKey, nodeModulesPath, runtime, ignoreInstall, buildTypeList, mode, deployMode, watch, generateMpType, generateMpPath, isCleanDistDir, plugins, extraData, isCrossAccount, resourceAppid, domain, }: BuildAppProps & {
    deployMode: DEPLOY_MODE;
    runtime: RUNTIME;
    ignoreInstall: boolean;
    isCrossAccount: boolean;
    resourceAppid?: string;
}, cb?: WebpackBuildCallBack): Promise<string | undefined>;
export declare function installDep(dir: any, opts?: IInstallOpts): Promise<void>;
export default buildWebApp;
//# sourceMappingURL=index.d.ts.map