"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMpConfig = void 0;
const path = __importStar(require("path"));
const lodash_1 = require("lodash");
const mp_1 = require("../config/mp");
const weapps_core_1 = require("../../weapps-core");
const config_1 = require("../config");
const net_1 = require("../util/net");
const chalk_1 = __importDefault(require("chalk"));
function generateMpConfig(weapps, ctx) {
    var _a;
    const appConfig = {
        useExtendedLib: { weui: true },
    };
    const { miniprogramPlugins = [] } = ctx;
    const projConfig = lodash_1.merge({}, mp_1.defaultProjConfig, {
        projectname: 'WeDa-' + ctx.appId,
    });
    const pageConfigs = weapps.map((app) => {
        var _a;
        const pageConfig = {};
        const kbConfig = (_a = app.lowCodes) === null || _a === void 0 ? void 0 : _a.find((m) => m.name === config_1.MP_CONFIG_MODULE_NAME);
        if (kbConfig) {
            const { pagesConfigJson = {} } = eval(`(${kbConfig.code.replace(/export\s+default/, '')})`);
            lodash_1.merge(pageConfig, pagesConfigJson);
        }
        lodash_1.merge(pageConfig, getAppPagesConfig((app === null || app === void 0 ? void 0 : app.pageInstanceList) || []));
        return pageConfig;
    });
    const kbConfig = (_a = weapps[0].lowCodes) === null || _a === void 0 ? void 0 : _a.find((m) => m.name === config_1.MP_CONFIG_MODULE_NAME);
    if (kbConfig) {
        const { projectConfigJson = {}, appJson = {} } = eval(`(${kbConfig.code.replace(/export\s+default/, '')})`);
        lodash_1.merge(projConfig, projectConfigJson);
        const matertialMetaIgnores = ctx.materialLibs
            .filter((lib) => !lib.isComposite)
            .reduce((arr, lib) => {
            arr.push({ type: 'file', value: `materials/${lib.name}/meta.json` });
            return arr;
        }, []);
        projConfig.packOptions.ignore.push(...matertialMetaIgnores);
        if (appJson.tabBar) {
            parseTabConfig(appJson.tabBar, ctx.projDir);
        }
        lodash_1.merge(appConfig, appJson);
    }
    const _b = weapps[0].appConfig || {}, { tradingCapability } = _b, mainAppConfig = __rest(_b, ["tradingCapability"]);
    lodash_1.merge(appConfig, mainAppConfig, extractPages(weapps, pageConfigs));
    if (tradingCapability) {
        const tradePluginKey = `weda-mini-shop-plugin`;
        const pluginMeta = {
            version: 'latest',
            provider: 'wx34345ae5855f892d',
        };
        let { plugins = {} } = appConfig;
        let find = false;
        for (let key in plugins) {
            let value = plugins[key];
            if (key === tradePluginKey || value.provider === pluginMeta.provider) {
                find = true;
                break;
            }
        }
        if (!find) {
            plugins[tradePluginKey] = pluginMeta;
        }
        appConfig.plugins = plugins;
    }
    miniprogramPlugins.forEach((plugin) => {
        var _a, _b;
        if (!((_b = (_a = appConfig) === null || _a === void 0 ? void 0 : _a.plugins) === null || _b === void 0 ? void 0 : _b[plugin.name])) {
            lodash_1.set(appConfig, `plugins.${plugin.name}`, {
                version: plugin.version,
                provider: plugin.pluginAppId,
            });
        }
    });
    return { appConfig, projConfig, pageConfigs };
}
exports.generateMpConfig = generateMpConfig;
function extractPages(weapps, pageConfigs) {
    const pages = [];
    const subpackages = [];
    let homePage = '';
    let homePageId = '';
    weapps.forEach((weapp, index) => {
        const { rootPath } = weapp;
        const subPackage = { root: rootPath, pages: [] };
        if (rootPath) {
            subpackages.push(subPackage);
        }
        weapps_core_1.loopDealWithFn(weapp.pageInstanceList || [], (page) => {
            const pageConfig = pageConfigs[index];
            const pageFileName = lodash_1.get(pageConfig, `${page.id}.pageFileName`, 'index');
            if (rootPath) {
                subPackage.pages.push(`pages/${page.id}/${pageFileName}`);
            }
            else if (!page.isHome) {
                pages.push(`pages/${page.id}/${pageFileName}`);
            }
            else {
                homePage = `pages/${page.id}/${pageFileName}`;
                homePageId = page.id;
            }
        });
    });
    if (homePage) {
        pages.unshift(homePage);
    }
    return { pages, subpackages, homePageId };
}
function getAppPagesConfig(pages) {
    const pagesConfig = {};
    pages.map((page) => {
        const pageConfig = transformDynamicData(page.data);
        delete pageConfig['title'];
        pagesConfig[page.id] = pageConfig;
    });
    return pagesConfig;
}
function transformDynamicData(originData) {
    const temp = {};
    for (const key in originData) {
        const target = originData[key];
        if (target && target.value) {
            temp[key] = target.value;
        }
    }
    return temp;
}
function parseTabConfig(tabBar, projDir) {
    tabBar.list.map((tab, index) => {
        const { iconPath, selectedIconPath } = tab;
        if (iconPath) {
            tab.iconPath = parseTabIcon(iconPath, index, 'icon');
        }
        if (selectedIconPath) {
            tab.selectedIconPath = parseTabIcon(selectedIconPath, index, 'selectedIcon');
        }
    });
    function parseTabIcon(iconUrl, index, filename) {
        if (typeof iconUrl !== 'string') {
            console.error(chalk_1.default.red('App.json invalid tabbar icon path'), iconUrl);
            return;
        }
        const iconPath = 'assets/tab' + index + '/' + filename + path.extname(iconUrl);
        net_1.downloadFile(iconUrl, projDir + '/' + iconPath).catch((e) => {
            console.error(chalk_1.default.red(`Fail to download tabBar icon from ${iconUrl}`), e);
        });
        return iconPath;
    }
}
