import { ActionType, IComponentSchemaJson, IListenerInstance, IMaterialItem, IPageInstance, IWebRuntimeAppData, IExtraData, IBuildType, IWeAppComponentInstance } from '../../weapps-core';
import { IComponentsInfoMap, IFileCodeMap } from '../types/common';
import { Schema } from '@formily/react-schema-renderer';
import { DEPLOY_MODE, RUNTIME } from '../../types';
export declare function runGenerateCore(props: {
    appBuildDir: string;
    appData: IWebRuntimeAppData;
    subAppDataList: IWebRuntimeAppData[];
    dependencies: IMaterialItem[];
    appKey: string;
    buildTypeList: IBuildType[];
    basename: string;
    deployMode: DEPLOY_MODE;
    runtime: RUNTIME;
    ignoreInstall: boolean;
    extraData: {
        isComposite: boolean;
        compProps: any;
    };
    i18nConfig: any;
    fileCodeMap: IFileCodeMap;
    isSandbox: boolean;
}): Promise<void>;
export interface IOriginKeyInfo {
    sourceKey: string;
    name: string;
    materialName: string;
    materialVersion: string;
    key: string;
    variableName: string;
    type?: ActionType;
    isComposite?: boolean;
    isPlainProps?: boolean;
    entry?: string;
}
export declare function generateSinglePageJsxFile(pageInstance: IPageInstance, appBuildDir: string, rootPath: string, dependencies: IMaterialItem[] | undefined, extraData: {
    isComposite: boolean;
    compProps: any;
} | undefined, fileCodeMap: IFileCodeMap, isSandbox: boolean): Promise<void>;
export declare function getOriginComponentAndActionList(componentSchema: IComponentSchemaJson, dependencies: IMaterialItem[], originComponentList?: IOriginKeyInfo[], originActionList?: IOriginKeyInfo[], genericCompMap?: Record<string, IWeAppComponentInstance['genericComp']>): {
    originComponentList: IOriginKeyInfo[];
    originActionList: IOriginKeyInfo[];
};
export declare function pullActionToListByInstances(listenerInstances: any, originActionList: any, fixedDependencies: (IMaterialItem & {
    isPlainProps?: boolean;
    entry?: string;
})[]): void;
export declare function pullComponentToListByInstance(sourceKey: string, originComponentList: IOriginKeyInfo[], fixedDependencies: IMaterialItem[]): void;
export declare function isSlot(comp: Schema): boolean | "" | undefined;
export declare function getComponentSchemaString(componentSchema: IComponentSchemaJson, isComposite?: boolean, componentsInfoMap?: IComponentsInfoMap, wrapperClass?: string): {
    widgets: string;
    dataBinds: string;
    componentSchema: string;
};
export declare function getListenersString(listeners?: IListenerInstance[], isComposite?: boolean): string;
export declare function generateRouterFile(allAppDataList: IWebRuntimeAppData[], appBuildDir: string, basename: string | undefined, fileCodeMap: IFileCodeMap, isSandbox: any): Promise<void>;
export declare function writeLowCodeFiles(appData: IWebRuntimeAppData, appBuildDir: string, fileCodeMap: IFileCodeMap, rootPath: string): Promise<void>;
export declare function generateCodeFromTpl(appKey: string, appData: IWebRuntimeAppData, appBuildDir: string, rootPath: string, extraData: IExtraData, i18nConfig: any, fileCodeMap: IFileCodeMap, isSandbox: boolean, subAppDataList: IWebRuntimeAppData[], buildTypeList: IBuildType[], deployMode: DEPLOY_MODE, domain: string): Promise<void>;
//# sourceMappingURL=generate.d.ts.map